Skip to main content

admin.apps.mcp.servers.permissions.set method

The features within are only available to Slack workspaces on an Enterprise plan.

Don't have a paid plan? Join the Developer Program and provision a fully-featured sandbox for free.

Facts

DescriptionSet the access control permission for who can use an MCP server
Method Access
POST https://slack.com/api/admin.apps.mcp.servers.permissions.set
Scopes
User token:
Content types
application/x-www-form-urlencoded
application/json

Arguments

Required arguments

tokenstringRequired

Authentication token bearing required scopes. Tokens should be passed as an HTTP Authorization header or alternatively, as a POST parameter.

Example: xxxx-xxxxxxxxx-xxxx
app_idstringRequired

Encoded ID of the app

Example: A0000000001
server_idstringRequired

Encoded ID of the MCP server

Example: Amcp0000000001
permission_typestringRequired

The type of permission that defines who can use this MCP server

Acceptable values: everyone no_one named_entities named_entities_exclude

Optional arguments

user_idsarrayOptional

List of user IDs to set for named_entities or named_entities_exclude

Example: ['U00000001', 'U00000002']
usergroup_idsarrayOptional

List of encoded usergroup IDs

Example: S00000001,S00000002

Usage info

This method sets the permission_type for a specific MCP server, defining who in the org can use it. When the permission_type field is set to named_entities or named_entities_exclude, pass either or both user_ids and usergroup_ids values to define the entities the rule applies to.

To view the current permissions for an app's MCP servers, use the admin.apps.mcp.servers.permissions.list method. To list the MCP servers approved across the org, use the admin.apps.mcp.servers.list method.


Response

Errors

This table lists the expected errors that this method could return. However, other errors can be returned in the case where the service is down or other unexpected factors affect processing. Callers should always check the value of the ok parameter in the response.

Error
Description
access_denied

Access to a resource specified in the request is denied.

accesslimited

Access to this method is limited on the current network

account_inactive

Authentication token is for a deleted user or workspace when using a bot token.

app_not_found

This app does not exist.

deprecated_endpoint

The endpoint has been deprecated.

ekm_access_denied

Administrators have suspended the ability to post a message.

enterprise_is_restricted

The method cannot be called from an Enterprise.

fatal_error

The server could not complete your operation(s) without encountering a catastrophic error. It's possible some aspect of the operation succeeded before the error was raised.

feature_not_enabled

The MCP server ACL feature is not enabled for this team.

internal_error

The server could not complete your operation(s) without encountering an error, likely due to a transient issue on our end. It's possible some aspect of the operation succeeded before the error was raised.

invalid_arg_name

The method was passed an argument whose name falls outside the bounds of accepted or expected values. This includes very long names and names with non-alphanumeric characters other than _. If you get this error, it is typically an indication that you have made a very malformed API call.

invalid_arguments

The method was called with invalid arguments.

invalid_array_arg

The method was passed an array as an argument. Please only input valid strings.

invalid_auth

Invalid authorization token

invalid_auth

Some aspect of authentication cannot be validated. Either the provided token is invalid or the request originates from an IP address disallowed from making the request.

invalid_charset

The method was called via a POST request, but the charset specified in the Content-Type header was invalid. Valid charset names are: utf-8 iso-8859-1.

invalid_form_data

The method was called via a POST request with Content-Type application/x-www-form-urlencoded or multipart/form-data, but the form data was either missing or syntactically invalid.

invalid_permission_type

The permission_type value is not valid.

invalid_post_type

The method was called via a POST request, but the specified Content-Type was invalid. Valid types are: application/json application/x-www-form-urlencoded multipart/form-data text/plain.

method_deprecated

The method has been deprecated.

missing_post_type

The method was called via a POST request and included a data payload, but the request did not include a Content-Type header.

missing_scope

The token used is not granted the specific scope permissions required to complete this request.

named_entities_cannot_be_empty

Must pass at least one valid named entity when permission_type is named_entities or named_entities_exclude.

no_permission

The workspace token used in this request does not have the permissions necessary to complete the request. Make sure your app is a member of the conversation it's attempting to post a message to.

no_valid_named_entities

None of the provided named entities were valid.

not_allowed_token_type

The token type used in this request is not allowed.

not_an_enterprise

This feature is only available on Enterprise Grid plans.

not_authed

No authentication token provided.

org_login_required

The workspace is undergoing an enterprise migration and will not be available until migration is complete.

ratelimited

The request has been ratelimited. Refer to the Retry-After header for when to retry the request.

request_timeout

The method was called via a POST request, but the POST data was either missing or truncated.

restricted_action

User does not have permission to perform this action.

server_acl_entities_not_in_scope

One or more entities in the server ACL are not in scope of the app-level ACL.

server_acl_type_broader_than_app

The chosen permission type is broader than the app-level ACL allows.

server_not_found

The specified MCP server does not exist for this app.

service_unavailable

The service is temporarily unavailable

team_access_not_granted

The token used is not granted the specific workspace access required to complete this request.

team_added_to_org

The workspace associated with your request is currently undergoing migration to an Enterprise Organization. Web API and other platform operations will be intermittently unavailable until the transition is complete.

token_expired

Authentication token has expired

token_revoked

Authentication token is for a deleted user or workspace or the app has been removed when using a user token.

too_many_named_entities

Too many named entities provided.

two_factor_setup_required

Two factor setup is required.

user_not_found

One or more user IDs are not valid.

usergroup_not_found

One or more usergroup IDs are not valid.